田草博客,logo
日志搜索


 标题   内容 评论


网友交流QQ群:11740834 需注明申请加入原因

微信 公众号:ByCAD

邮箱:tiancao1001x126.com
ByCAD,微信公众号
日志首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范 | 软件
-电信用户-|-网通用户-
-博客论坛-|-软件下载-
-网站导航-|-规范下载-
-BelovedFLash欣赏-

用户登陆
用户:
密码:
 

站点日历
73 2018 - 10 48
 123456
78910111213
14151617181920
21222324252627
28293031


站点统计

最新评论



已知三点坐标求三角形面积 In VB.NET Many Source Of Load Images In PictureBox
未知 判断点是否在多边形内部   [ 日期:2017-09-14 ]   [ 来自:本站原创 ]  HTML


判断点是否在多边形内部

http://bbs.mjtd.com/thread-92445-1-1.html

Public Function ptInPolygon1(pt As Point3d, pPolyline As Polyline) As Integer
    Dim count As Integer = pPolyline.NumberOfVertices
    '构建多边形外接矩形
    Dim maxx As Double = Double.MinValue, maxy As Double = Double.MinValue, minx As Double = Double.MaxValue, miny As Double = Double.MaxValue
    Dim i As Integer = 0
    While i < count
        If pPolyline.GetPoint3dAt(i).X > maxx Then
            maxx = pPolyline.GetPoint3dAt(i).X
        End If
        If pPolyline.GetPoint3dAt(i).Y > maxy Then
            maxy = pPolyline.GetPoint3dAt(i).Y
        End If
        If pPolyline.GetPoint3dAt(i).X < minx Then
            minx = pPolyline.GetPoint3dAt(i).X
        End If
        If pPolyline.GetPoint3dAt(i).Y < miny Then
            miny = pPolyline.GetPoint3dAt(i).Y
        End If
        System.Math.Max(System.Threading.Interlocked.Increment(i),i - 1)
    End While
    If pt.X > maxx OrElse pt.Y > maxy OrElse pt.X < minx OrElse pt.Y < miny Then
        Return -1
    End If

    Dim line1 As New Line(New Point3d(maxx, pt.Y, 0), New Point3d(minx, pt.Y, 0))

    Dim crossCount As Integer = 0

    Using tran As Transaction = pDatabase.TransactionManager.StartTransaction()
        Dim pBlockTableRecord As BlockTableRecord = TryCast(tran.GetObject(pDatabase.CurrentSpaceId, OpenMode.ForWrite), BlockTableRecord)

        Dim crossPoint As New Point3dCollection()

        line1.IntersectWith(pPolyline, Intersect.OnBothOperands, crossPoint, 0, 0)
        If crossPoint.Count >= 1 Then
            Dim n As Integer = 0
            While n < crossPoint.Count
                Dim crossPt As Point3d = crossPoint(n)
                If crossPt.X > pt.X Then
                    System.Math.Max(System.Threading.Interlocked.Increment(crossCount),crossCount - 1)

                    Dim pCircle As New Circle(crossPt, Vector3d.ZAxis, 2)

                    pBlockTableRecord.AppendEntity(pCircle)
                    tran.AddNewlyCreatedDBObject(pCircle, True)
                End If
                System.Math.Max(System.Threading.Interlocked.Increment(n),n - 1)

            End While
        End If
        Dim circle As New Circle(pt, Vector3d.ZAxis, 2)
        pBlockTableRecord.AppendEntity(circle)
        tran.AddNewlyCreatedDBObject(circle, True)

        pBlockTableRecord.AppendEntity(line1)
        tran.AddNewlyCreatedDBObject(line1, True)
        tran.Commit()
    End Using
    Return crossCount Mod 2

End Function

还可以参考 :http://bbs.xdcad.net/thread-715959-1-1.html




[本日志由 tiancao1001 于 2018-08-07 09:11 PM 编辑]


引用这个评论 homemisha 于 2017-09-16 09:55 PM 发表评论: 
看不到啊,亲

发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:3*6=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
版权所有:田草博客
tiancao1001&126.com网友交流QQ群:11740834
Powered by L-Blog V1.08 (SE) Final© 2007-2009